// Generated by gir (https://github.com/gtk-rs/gir @ 6fbc68a47551)
// from
// from gir-files (@ 7ebd4478b4a5)
// DO NOT EDIT

use std::env;
use std::error::Error;
use std::ffi::OsString;
use std::mem::{align_of, size_of};
use std::path::Path;
use std::process::Command;
use std::str;
use tempfile::Builder;
use template_glib_sys::*;

static PACKAGES: &[&str] = &["template-glib-1.0"];

#[derive(Clone, Debug)]
struct Compiler {
    pub args: Vec<String>,
}

impl Compiler {
    pub fn new() -> Result<Self, Box<dyn Error>> {
        let mut args = get_var("CC", "cc")?;
        args.push("-Wno-deprecated-declarations".to_owned());
        // For _Generic
        args.push("-std=c11".to_owned());
        // For %z support in printf when using MinGW.
        args.push("-D__USE_MINGW_ANSI_STDIO".to_owned());
        args.extend(get_var("CFLAGS", "")?);
        args.extend(get_var("CPPFLAGS", "")?);
        args.extend(pkg_config_cflags(PACKAGES)?);
        Ok(Self { args })
    }

    pub fn compile(&self, src: &Path, out: &Path) -> Result<(), Box<dyn Error>> {
        let mut cmd = self.to_command();
        cmd.arg(src);
        cmd.arg("-o");
        cmd.arg(out);
        let status = cmd.spawn()?.wait()?;
        if !status.success() {
            return Err(format!("compilation command {:?} failed, {}", &cmd, status).into());
        }
        Ok(())
    }

    fn to_command(&self) -> Command {
        let mut cmd = Command::new(&self.args[0]);
        cmd.args(&self.args[1..]);
        cmd
    }
}

fn get_var(name: &str, default: &str) -> Result<Vec<String>, Box<dyn Error>> {
    match env::var(name) {
        Ok(value) => Ok(shell_words::split(&value)?),
        Err(env::VarError::NotPresent) => Ok(shell_words::split(default)?),
        Err(err) => Err(format!("{} {}", name, err).into()),
    }
}

fn pkg_config_cflags(packages: &[&str]) -> Result<Vec<String>, Box<dyn Error>> {
    if packages.is_empty() {
        return Ok(Vec::new());
    }
    let pkg_config = env::var_os("PKG_CONFIG").unwrap_or_else(|| OsString::from("pkg-config"));
    let mut cmd = Command::new(pkg_config);
    cmd.arg("--cflags");
    cmd.args(packages);
    let out = cmd.output()?;
    if !out.status.success() {
        return Err(format!("command {:?} returned {}", &cmd, out.status).into());
    }
    let stdout = str::from_utf8(&out.stdout)?;
    Ok(shell_words::split(stdout.trim())?)
}

#[derive(Copy, Clone, Debug, Eq, PartialEq)]
struct Layout {
    size: usize,
    alignment: usize,
}

#[derive(Copy, Clone, Debug, Default, Eq, PartialEq)]
struct Results {
    /// Number of successfully completed tests.
    passed: usize,
    /// Total number of failed tests (including those that failed to compile).
    failed: usize,
}

impl Results {
    fn record_passed(&mut self) {
        self.passed += 1;
    }
    fn record_failed(&mut self) {
        self.failed += 1;
    }
    fn summary(&self) -> String {
        format!("{} passed; {} failed", self.passed, self.failed)
    }
    fn expect_total_success(&self) {
        if self.failed == 0 {
            println!("OK: {}", self.summary());
        } else {
            panic!("FAILED: {}", self.summary());
        };
    }
}

#[test]
#[cfg(target_os = "linux")]
fn cross_validate_constants_with_c() {
    let mut c_constants: Vec<(String, String)> = Vec::new();

    for l in get_c_output("constant").unwrap().lines() {
        let mut words = l.trim().split(';');
        let name = words.next().expect("Failed to parse name").to_owned();
        let value = words
            .next()
            .and_then(|s| s.parse().ok())
            .expect("Failed to parse value");
        c_constants.push((name, value));
    }

    let mut results = Results::default();

    for ((rust_name, rust_value), (c_name, c_value)) in
        RUST_CONSTANTS.iter().zip(c_constants.iter())
    {
        if rust_name != c_name {
            results.record_failed();
            eprintln!("Name mismatch:\nRust: {:?}\nC:    {:?}", rust_name, c_name,);
            continue;
        }

        if rust_value != c_value {
            results.record_failed();
            eprintln!(
                "Constant value mismatch for {}\nRust: {:?}\nC:    {:?}",
                rust_name, rust_value, &c_value
            );
            continue;
        }

        results.record_passed();
    }

    results.expect_total_success();
}

#[test]
#[cfg(target_os = "linux")]
fn cross_validate_layout_with_c() {
    let mut c_layouts = Vec::new();

    for l in get_c_output("layout").unwrap().lines() {
        let mut words = l.trim().split(';');
        let name = words.next().expect("Failed to parse name").to_owned();
        let size = words
            .next()
            .and_then(|s| s.parse().ok())
            .expect("Failed to parse size");
        let alignment = words
            .next()
            .and_then(|s| s.parse().ok())
            .expect("Failed to parse alignment");
        c_layouts.push((name, Layout { size, alignment }));
    }

    let mut results = Results::default();

    for ((rust_name, rust_layout), (c_name, c_layout)) in RUST_LAYOUTS.iter().zip(c_layouts.iter())
    {
        if rust_name != c_name {
            results.record_failed();
            eprintln!("Name mismatch:\nRust: {:?}\nC:    {:?}", rust_name, c_name,);
            continue;
        }

        if rust_layout != c_layout {
            results.record_failed();
            eprintln!(
                "Layout mismatch for {}\nRust: {:?}\nC:    {:?}",
                rust_name, rust_layout, &c_layout
            );
            continue;
        }

        results.record_passed();
    }

    results.expect_total_success();
}

fn get_c_output(name: &str) -> Result<String, Box<dyn Error>> {
    let tmpdir = Builder::new().prefix("abi").tempdir()?;
    let exe = tmpdir.path().join(name);
    let c_file = Path::new("tests").join(name).with_extension("c");

    let cc = Compiler::new().expect("configured compiler");
    cc.compile(&c_file, &exe)?;

    let mut abi_cmd = Command::new(exe);
    let output = abi_cmd.output()?;
    if !output.status.success() {
        return Err(format!("command {:?} failed, {:?}", &abi_cmd, &output).into());
    }

    Ok(String::from_utf8(output.stdout)?)
}

const RUST_LAYOUTS: &[(&str, Layout)] = &[
    (
        "TmplError",
        Layout {
            size: size_of::<TmplError>(),
            alignment: align_of::<TmplError>(),
        },
    ),
    (
        "TmplExprBuiltin",
        Layout {
            size: size_of::<TmplExprBuiltin>(),
            alignment: align_of::<TmplExprBuiltin>(),
        },
    ),
    (
        "TmplExprType",
        Layout {
            size: size_of::<TmplExprType>(),
            alignment: align_of::<TmplExprType>(),
        },
    ),
    (
        "TmplSymbolType",
        Layout {
            size: size_of::<TmplSymbolType>(),
            alignment: align_of::<TmplSymbolType>(),
        },
    ),
    (
        "TmplTemplate",
        Layout {
            size: size_of::<TmplTemplate>(),
            alignment: align_of::<TmplTemplate>(),
        },
    ),
    (
        "TmplTemplateClass",
        Layout {
            size: size_of::<TmplTemplateClass>(),
            alignment: align_of::<TmplTemplateClass>(),
        },
    ),
    (
        "TmplTemplateLocator",
        Layout {
            size: size_of::<TmplTemplateLocator>(),
            alignment: align_of::<TmplTemplateLocator>(),
        },
    ),
    (
        "TmplTemplateLocatorClass",
        Layout {
            size: size_of::<TmplTemplateLocatorClass>(),
            alignment: align_of::<TmplTemplateLocatorClass>(),
        },
    ),
];

const RUST_CONSTANTS: &[(&str, &str)] = &[
    ("TMPL_ENABLE_TRACE", "0"),
    ("(gint) TMPL_ERROR_CIRCULAR_INCLUDE", "3"),
    ("(gint) TMPL_ERROR_DIVIDE_BY_ZERO", "8"),
    ("(gint) TMPL_ERROR_GI_FAILURE", "14"),
    ("(gint) TMPL_ERROR_INVALID_OP_CODE", "7"),
    ("(gint) TMPL_ERROR_INVALID_STATE", "1"),
    ("(gint) TMPL_ERROR_LEXER_FAILURE", "5"),
    ("(gint) TMPL_ERROR_MISSING_SYMBOL", "9"),
    ("(gint) TMPL_ERROR_NOT_AN_OBJECT", "11"),
    ("(gint) TMPL_ERROR_NOT_A_FUNCTION", "18"),
    ("(gint) TMPL_ERROR_NOT_A_VALUE", "17"),
    ("(gint) TMPL_ERROR_NOT_IMPLEMENTED", "16"),
    ("(gint) TMPL_ERROR_NO_SUCH_PROPERTY", "13"),
    ("(gint) TMPL_ERROR_NULL_POINTER", "12"),
    ("(gint) TMPL_ERROR_RUNTIME_ERROR", "15"),
    ("(gint) TMPL_ERROR_SYMBOL_REDEFINED", "10"),
    ("(gint) TMPL_ERROR_SYNTAX_ERROR", "4"),
    ("(gint) TMPL_ERROR_TEMPLATE_NOT_FOUND", "2"),
    ("(gint) TMPL_ERROR_TYPE_MISMATCH", "6"),
    ("(gint) TMPL_EXPR_ADD", "1"),
    ("(gint) TMPL_EXPR_AND", "27"),
    ("(gint) TMPL_EXPR_ANON_FN_CALL", "21"),
    ("(gint) TMPL_EXPR_ARGS", "30"),
    ("(gint) TMPL_EXPR_BOOLEAN", "5"),
    ("(gint) TMPL_EXPR_BUILTIN_ABS", "0"),
    ("(gint) TMPL_EXPR_BUILTIN_ASSERT", "9"),
    ("(gint) TMPL_EXPR_BUILTIN_CAST_BOOL", "22"),
    ("(gint) TMPL_EXPR_BUILTIN_CAST_BYTE", "14"),
    ("(gint) TMPL_EXPR_BUILTIN_CAST_CHAR", "15"),
    ("(gint) TMPL_EXPR_BUILTIN_CAST_DOUBLE", "21"),
    ("(gint) TMPL_EXPR_BUILTIN_CAST_FLOAT", "20"),
    ("(gint) TMPL_EXPR_BUILTIN_CAST_I32", "16"),
    ("(gint) TMPL_EXPR_BUILTIN_CAST_I64", "18"),
    ("(gint) TMPL_EXPR_BUILTIN_CAST_U32", "17"),
    ("(gint) TMPL_EXPR_BUILTIN_CAST_U64", "19"),
    ("(gint) TMPL_EXPR_BUILTIN_CEIL", "1"),
    ("(gint) TMPL_EXPR_BUILTIN_COS", "12"),
    ("(gint) TMPL_EXPR_BUILTIN_FLOOR", "2"),
    ("(gint) TMPL_EXPR_BUILTIN_HEX", "3"),
    ("(gint) TMPL_EXPR_BUILTIN_LOG", "4"),
    ("(gint) TMPL_EXPR_BUILTIN_PRINT", "5"),
    ("(gint) TMPL_EXPR_BUILTIN_PRINTERR", "13"),
    ("(gint) TMPL_EXPR_BUILTIN_REPR", "6"),
    ("(gint) TMPL_EXPR_BUILTIN_SIN", "10"),
    ("(gint) TMPL_EXPR_BUILTIN_SQRT", "7"),
    ("(gint) TMPL_EXPR_BUILTIN_TAN", "11"),
    ("(gint) TMPL_EXPR_BUILTIN_TYPEOF", "8"),
    ("(gint) TMPL_EXPR_DIV", "4"),
    ("(gint) TMPL_EXPR_EQ", "11"),
    ("(gint) TMPL_EXPR_FN_CALL", "20"),
    ("(gint) TMPL_EXPR_FUNC", "31"),
    ("(gint) TMPL_EXPR_GETATTR", "23"),
    ("(gint) TMPL_EXPR_GI_CALL", "25"),
    ("(gint) TMPL_EXPR_GT", "8"),
    ("(gint) TMPL_EXPR_GTE", "12"),
    ("(gint) TMPL_EXPR_IF", "16"),
    ("(gint) TMPL_EXPR_INVERT_BOOLEAN", "29"),
    ("(gint) TMPL_EXPR_LT", "9"),
    ("(gint) TMPL_EXPR_LTE", "13"),
    ("(gint) TMPL_EXPR_MUL", "3"),
    ("(gint) TMPL_EXPR_NE", "10"),
    ("(gint) TMPL_EXPR_NOP", "32"),
    ("(gint) TMPL_EXPR_NULL", "33"),
    ("(gint) TMPL_EXPR_NUMBER", "6"),
    ("(gint) TMPL_EXPR_OR", "28"),
    ("(gint) TMPL_EXPR_REQUIRE", "26"),
    ("(gint) TMPL_EXPR_SETATTR", "24"),
    ("(gint) TMPL_EXPR_STMT_LIST", "15"),
    ("(gint) TMPL_EXPR_STRING", "7"),
    ("(gint) TMPL_EXPR_SUB", "2"),
    ("(gint) TMPL_EXPR_SYMBOL_ASSIGN", "19"),
    ("(gint) TMPL_EXPR_SYMBOL_REF", "18"),
    ("(gint) TMPL_EXPR_UNARY_MINUS", "14"),
    ("(gint) TMPL_EXPR_USER_FN_CALL", "22"),
    ("(gint) TMPL_EXPR_WHILE", "17"),
    ("TMPL_LOG_LEVEL_TRACE", "1"),
    ("TMPL_MAJOR_VERSION", "3"),
    ("TMPL_MICRO_VERSION", "0"),
    ("TMPL_MINOR_VERSION", "35"),
    ("(gint) TMPL_SYMBOL_EXPR", "0"),
    ("(gint) TMPL_SYMBOL_VALUE", "1"),
    ("TMPL_VERSION_S", "3.35.0"),
];
